"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DashboardGenerator = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useMediaQuery = require("@material-ui/core/useMediaQuery");

var _styles = require("@material-ui/core/styles");

var R = _interopRequireWildcard(require("ramda"));

var _Widget = require("./Widget");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var defaultWidth = 300;
var wideWidth = 616;
var contentHeight = 332;
var propTypes = {
  dashboardConfig: _propTypes["default"].objectOf(_propTypes["default"].any),
  asset: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  componentMap: _propTypes["default"].objectOf(_propTypes["default"].node).isRequired
};
var defaultProps = {
  dashboardConfig: {}
};
var hoc = (0, _styles.withTheme)();

var DashboardGeneratorC = function DashboardGeneratorC(_ref) {
  var _ref$dashboardConfig = _ref.dashboardConfig,
      _ref$dashboardConfig$ = _ref$dashboardConfig.widgets,
      widgets = _ref$dashboardConfig$ === void 0 ? [] : _ref$dashboardConfig$,
      widgetsInDashboard = _ref$dashboardConfig.widgetsInDashboard,
      type = _ref.asset.type,
      theme = _ref.theme,
      componentMap = _ref.componentMap;

  // console.log('DaGen props:', widgets, widgetsInDashboard, type);
  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      widgetOrder = _useState2[0],
      setWidgetOrder = _useState2[1];

  var widgetComponent = (0, _react.useRef)({});
  (0, _react.useEffect)(function () {
    /* Clean up old items */
    var temporaryToRemoveOld = type && localStorage.getItem(type);

    if (temporaryToRemoveOld) {
      var order = JSON.parse(temporaryToRemoveOld).widgetOrder;
      if (order) localStorage.removeItem(type);
    }
    /* End of Clean up */


    var assetTypeCache = type ? JSON.parse(localStorage.getItem("aT_".concat(type))) || {} : {};
    var cashedOrder = assetTypeCache.widgetOrder;
    var cachedOk = Array.isArray(cashedOrder) && cashedOrder.length === (widgetsInDashboard && widgetsInDashboard.length);
    var newOrder;
    if (!cachedOk) newOrder = widgetsInDashboard || R.map(R.prop('id'))(widgets); // console.log('DA-GEN useEffect []:', widgetsInDashboard, assetTypeCache, cachedNotOk, newOrder);

    setWidgetOrder(newOrder || cashedOrder);
    if (newOrder) localStorage.setItem("aT_".concat(type), JSON.stringify({
      widgetOrder: newOrder
    }));
  }, [widgetsInDashboard, type]); // useEffect(() => {
  //   document.body.style.backgroundColor = theme.palette.background[visible ? 'default' : 'paper'];
  //   return () => {
  //     document.body.style.backgroundColor = theme.palette.background.paper;
  //   };
  // }, [visible]);

  var moveWidget = function moveWidget(id, step) {
    var fromIndex = widgetOrder.indexOf(id);
    var newOrder = R.move(fromIndex, fromIndex + step)(widgetOrder);
    localStorage.setItem("aT_".concat(type), JSON.stringify({
      widgetOrder: newOrder
    }));
    setWidgetOrder(newOrder);
  };

  var getCommonMenuItems = function getCommonMenuItems(id) {
    return [{
      label: 'Move left',
      // tLabel('moveLeft', lang)
      icon: 'mdi-arrow-top-left',
      method: function method() {
        return moveWidget(id, -1);
      }
    }, {
      label: 'Move right',
      // tLabel('moveRight', lang)
      icon: 'mdi-arrow-bottom-right',
      method: function method() {
        return moveWidget(id, 1);
      }
    }];
  };

  var widgetBuilder = function widgetBuilder(widgetConf, dynWidth) {
    var id = widgetConf.id,
        _widgetConf$hoc = widgetConf.hoc,
        wHoc = _widgetConf$hoc === void 0 ? R.identity : _widgetConf$hoc,
        component = widgetConf.component,
        responsive = widgetConf.responsive,
        _widgetConf$justify = widgetConf.justify,
        justify = _widgetConf$justify === void 0 ? 'center' : _widgetConf$justify,
        _widgetConf$align = widgetConf.align,
        align = _widgetConf$align === void 0 ? 'center' : _widgetConf$align,
        _widgetConf$contentPr = widgetConf.contentProps,
        contentProps = _widgetConf$contentPr === void 0 ? {} : _widgetConf$contentPr,
        _widgetConf$frameProp = widgetConf.frameProps,
        frameProps = _widgetConf$frameProp === void 0 ? {} : _widgetConf$frameProp;

    if (!widgetComponent.current[id]) {
      var _componentMap$compone = componentMap[component],
          Inner = _componentMap$compone === void 0 ? Function.prototype : _componentMap$compone;
      widgetComponent.current[id] = wHoc(Inner);
    }

    var Component = widgetComponent.current[id];
    var width = responsive ? dynWidth : defaultWidth;
    var _frameProps$menuItems = frameProps.menuItems,
        menuItems = _frameProps$menuItems === void 0 ? [] : _frameProps$menuItems;
    return _react["default"].createElement(_Widget.Widget, _extends({
      width: width
    }, R.assoc('menuItems', R.concat(getCommonMenuItems(id), menuItems))(frameProps), {
      key: id,
      style: {
        marginTop: 16,
        marginLeft: 16
      }
    }), _react["default"].createElement("div", {
      style: {
        display: 'flex',
        justifyContent: justify,
        alignItems: align
      }
    }, _react["default"].createElement("div", null, _react["default"].createElement(Component, _extends({
      style: {
        height: contentHeight,
        width: width
      }
    }, contentProps)))));
  };

  var wide = (0, _useMediaQuery.unstable_useMediaQuery)(theme.breakpoints.up('md'));
  var dynWidth = wide ? wideWidth : defaultWidth; // console.log('DaGen b4 render:', widgetOrder);

  return _react["default"].createElement("div", null, R.map(function (id) {
    var conf = R.find(R.propEq('id', id))(widgets); // console.log('DaGen render widget:', conf);

    return conf && conf.component ? widgetBuilder(conf, dynWidth) : null;
  })(widgetOrder));
};

DashboardGeneratorC.propTypes = propTypes;
DashboardGeneratorC.defaultProps = defaultProps;
var DashboardGenerator = hoc(DashboardGeneratorC);
exports.DashboardGenerator = DashboardGenerator;