"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FlexIcon = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("mdi/css/materialdesignicons.min.css");

var _styles = require("@material-ui/core/styles");

var _Icon = _interopRequireDefault(require("@material-ui/core/Icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var styles = function styles() {
  return {};
};

var stringToThemeColor = function stringToThemeColor(string, theme) {
  if (string === 'inherit') return 'inherit';
  if (string === 'secondary') return theme.palette.secondary.main;
  if (string === 'primary') return theme.palette.primary.main;
  if (string === 'action') return theme.palette.action.active;
  if (string === 'disabled') return theme.palette.action.disabled;
  if (string === 'error') return theme.palette.error.main;
  return string;
};

var sizeToPix = {
  sm: '18px',
  md: '24px',
  lg: '36px',
  xl: '48px'
};

var sizeToPx = function sizeToPx(size) {
  return sizeToPix[size] || sizeToPix.md;
};

var propTypes = {
  children: _propTypes["default"].node,
  theme: _propTypes["default"].objectOf(_propTypes["default"].any).isRequired,
  style: _propTypes["default"].objectOf(_propTypes["default"].any),
  icon: _propTypes["default"].string,
  className: _propTypes["default"].string,
  size: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  color: _propTypes["default"].string // inherit, secondary, primary, action, disabled or error

};
var defaultProps = {
  children: undefined,
  color: undefined,
  className: '',
  size: 'md',
  style: {},
  icon: undefined
};

var __FlexIcon =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(__FlexIcon, _React$PureComponent);

  function __FlexIcon() {
    _classCallCheck(this, __FlexIcon);

    return _possibleConstructorReturn(this, _getPrototypeOf(__FlexIcon).apply(this, arguments));
  }

  _createClass(__FlexIcon, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          icon = _this$props.icon,
          style = _this$props.style,
          theme = _this$props.theme,
          color = _this$props.color,
          size = _this$props.size,
          children = _this$props.children,
          className = _this$props.className; // console.log('FLEXICON render:', icon, color, size, children);

      var iconStr = (children || icon).trim();
      var mdi = iconStr.startsWith('mdi-');
      var iconSize = typeof size === 'number' ? "".concat(size, "px") : sizeToPx(size);

      if (mdi) {
        return _react["default"].createElement("i", {
          style: _objectSpread({
            color: stringToThemeColor(color, theme),
            lineHeight: iconSize,
            height: iconSize
          }, style),
          className: "mdi ".concat(iconStr, " mdi-").concat(iconSize, " ").concat(className)
        });
      }

      var inlineStyle = _objectSpread({
        fontSize: iconSize
      }, style);

      if (color && (color.startsWith('#') || color.startsWith('rgb'))) {
        inlineStyle.color = color;
      }

      return _react["default"].createElement(_Icon["default"], {
        style: inlineStyle,
        color: color,
        className: className
      }, iconStr);
    }
  }]);

  return __FlexIcon;
}(_react["default"].PureComponent);

__FlexIcon.propTypes = propTypes;
__FlexIcon.defaultProps = defaultProps;
var FlexIcon = (0, _styles.withStyles)(styles, {
  withTheme: true
})(__FlexIcon);
exports.FlexIcon = FlexIcon;